/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var kmp = function (text) {
        var JI = new Continuation();
        var k;
        var n;
        var L0 = function () { JI(function () {
            k = k + 1;
            L1();
        });};
        var L1 = function () { JI(function () {
            if (text[k] != 'a') L0();
            k = k + 1;
            if (k > n) return -1;
            L2();
        });};
        var L2 = function () { JI(function () {
            if (text[k] != 'b') L1();
            k = k + 1;
            L3();
        });};
        var L3 = function () { JI(function () {
            if (text[k] != 'c') L1();
            k = k + 1;
            L4();
        });};
        var L4 = function () { JI(function () {
            if (text[k] != 'a') L0();
            k = k + 1;
            L5();
        });};
        var L5 = function () { JI(function () {
            if (text[k] != 'b') L1();
            k = k + 1;
            L6();
        });};
        var L6 = function () { JI(function () {
            if (text[k] != 'c') L1();
            k = k + 1;
            L7();
        });};
        var L7 = function () { JI(function () {
            if (text[k] != 'a') L0();
            k = k + 1;
            L8();
        });};
        var L8 = function () { JI(function () {
            if (text[k] != 'c') L5();
            k = k + 1;
            L9();
        });};
        var L9 = function () { JI(function () {
            if (text[k] != 'a') L0();
            k = k + 1;
            L10();
        });};
        var L10 = function () { JI(function () {
            if (text[k] != 'b') L1();
            k = k + 1;
            return k - 10;
        });};
        return function () {
            k = 0;
            n = text.length;
            text = text + "@a";
            L0();
        };
    };
    return function () {
        print(kmp("ababcabcabcacabcacab")());
    };
};
main()();
