/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var A;
    var qs = function (m, n) {
        var JI = new Continuation();
        var i;
        var j;
        var v;
        var loop1 = function () { JI(function () {
            if (A[i] > v) {
                A[j] = A[i];
                upf();
            }
            upt();
        });};
        var upt = function () { JI(function () {
            i = i + 1;
            if (i < j) loop1();
            common();
        });};
        var loop2 = function () { JI(function () {
            if (v > A[j]) {
                A[i] = A[j];
                upt();
            }
            upf();
        });};
        var upf = function () { JI(function () {
            j = j - 1;
            if (i < j) loop2();
            common();
        });};
        var common = function () { JI(function () {
            A[j] = v;
            if (n - m > 1) {
                qs(m, j - 1)();
                qs(j + 1, n)();
            }
        });};
        return function () {
            i = m;
            j = n;
            v = A[j];
            loop1();
        };
    };
    return function () {
        A = [5, 2, 1, 4, 6, 3];
        print("Random: " + A);
        qs(0, A.length - 1)();
        print("Sorted: " + A);
    };
};
main()();
var main = function () {
    var JI = new Continuation();
    var A;
    var qs = function (m, n) {
        var JI = new Continuation();
        var i;
        var j;
        var v;
        var upt = function () { JI(function () {
            {
                var loop = function () { JI(function () {
                    if (A[i] > v) {
                        A[j] = A[i];
                        (function () { upt = new Continuation(); upf(); })();
                    }
                    i = i + 1;
                    if (i < j) loop();
                    common();
                });};
                loop();
            }
        });};
        var upf = function () { JI(function () {
            {
                var loop = function () { JI(function () {
                    if (v > A[j]) {
                        A[i] = A[j];
                        (function () { upf = new Continuation(); upt(); })();
                    }
                    j = j - 1;
                    if (i < j) loop();
                    common();
                });};
                loop();
            }
        });};
        var common = function () { JI(function () {
            A[j] = v;
            if (n - m > 1) {
                qs(m, j - 1)();
                qs(j + 1, n)();
            }
        });};
        return function () {
            i = m;
            j = n;
            v = A[j];
            upt();
        };
    };
    return function () {
        A = [5, 2, 1, 4, 6, 3];
        print("Random: " + A);
        qs(0, A.length - 1)();
        print("Sorted: " + A);
    };
};
main()();
