/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var i;
    var loop = function () { JI(function () {
        i = i - 1;
        if (i > 0) loop();
    });};
    return function () {
        i = 1000000;
        loop();
    };
};
main()();
