/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var x1 = function () {
        var JI = new Continuation();
        return function () {
            return 1;
        };
    };
    var x2 = function () {
        var JI = new Continuation();
        return function () {
            return -1;
        };
    };
    var x3 = function () {
        var JI = new Continuation();
        return function () {
            return -1;
        };
    };
    var x4 = function () {
        var JI = new Continuation();
        return function () {
            return 1;
        };
    };
    var x5 = function () {
        var JI = new Continuation();
        return function () {
            return 0;
        };
    };
    var A = function (k, x1, x2, x3, x4, x5) {
        var JI = new Continuation();
        var B = function () {
            var JI = new Continuation();
            return function () {
                k = k - 1;
                return A(k, B, x1, x2, x3, x4)();
            };
        };
        return function () {
            if (k < 1) return x4()() + x5()();
            return B()();
        };
    };
    return function () {
        print(A(10, x1, x2, x3, x4, x5)());
    };
};
main()();
