/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var ps;
    var ts;
    var pp = function (m, ps) {
        var JI = new Continuation();
        return function () {
            if (m == 0) return undefined;
            pp(m - 1, ps)();
            print("(" + ps[m - 1][0] + ", " + ps[m - 1][1] + ")");
        };
    };
    var pt = function (m, ts) {
        var JI = new Continuation();
        return function () {
            if (m == 0) return undefined;
            pt(m - 1, ts)();
            print("(" + ts[m - 1][0] + ", " + ts[m - 1][1] + ", " + ts[m - 1][2] + ")");
        };
    };
    var PTT = function (n, ps) {
        var JI = new Continuation();
        var i;
        var j;
        var x;
        var ts;
        var next = function () {
            var JI = new Continuation();
            var k;
            var l;
            var loopP = function () { JI(function () {
                x = ps[k][l];
                (function () { l1 = new Continuation(); l2(); })();
                l = l + 1;
                if (l > 1) {
                    l = 0;
                    k = k + 1;
                }
                loopP();
            });};
            return function () {
                k = 0;
                l = 0;
                loopP();
            };
        };
        var exhausted = function () { JI(function () {
            return ts;
        });};
        var loopT = function () { JI(function () {
            if (n == 0) exhausted();
            l1();
        });};
        var l1 = function () { JI(function () {
            next()();
            l2();
        });};
        var l2 = function () { JI(function () {
            ts[i][j] = x;
            n = n - 1;
            j = j + 1;
            if (j > 2) {
                j = 0;
                i = i + 1;
                ts[i] = [];
            }
            loopT();
        });};
        return function () {
            i = 0;
            j = 0;
            ts = [];
            ts[i] = [];
            loopT();
        };
    };
    return function () {
        ps = [[1, 2], [3, 4], [5, 6]];
        pp(3, ps)();
        ts = PTT(6, ps)();
        pt(2, ts)();
    };
};
main()();
